=== python/requirements.txt ===
six
future
decorator
opm
numpy
