## opm-simulators 2025.10~git20251006.d7b21ed73+ds

=== debian/changelog ===
opm-simulators (2025.10~git20251006.d7b21ed73+ds-1) experimental; urgency=medium

  * Prerelease version based on commit d7b21ed
  * Depend on OPM 2025.10

 -- Markus Blatt <markus@dr-blatt.de>  Thu, 09 Oct 2025 22:09:35 +0200
