## opm-simulators 2025.10%2Bds

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
                libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
                zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
                texlive-latex-extra, texlive-latex-recommended, ghostscript,
-               libopm-grid-dev (>= 2025.04~),
+               libopm-grid-dev (>= 2025.10~),
 	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
 	       pybind11-dev, libhdf5-mpi-dev
 Standards-Version: 4.7.2
@@ -19,7 +19,7 @@
 Package: libopm-models-dev
 Architecture: all
 Section: oldlibs
-Depends: libopm-simulators-dev (>= 2025.04~),
+Depends: libopm-simulators-dev (>= 2025.10~),
          ${misc:Depends}
 Description: transitional package
  This is a transitional package. It can safely be removed.
@@ -28,7 +28,7 @@
 Section: libdevel
 Architecture: amd64 arm64 armel ia64 m68k mips64el mipsel ppc64el riscv64 loong64
 Multi-Arch: same
-Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2025.04~),
+Depends: ${opm:shared-library}, ${misc:Depends}, libopm-grid-dev (>= 2025.10~),
          libboost-date-time-dev, python3-opm-common
 Replaces: libopm-simulators1-dev,
           libopm-models-dev (<< 2025.04~)
@@ -101,7 +101,7 @@
 Package: libopm-models-doc
 Architecture: all
 Section: oldlibs
-Depends: libopm-simulators-doc (>= 2025.04~),
+Depends: libopm-simulators-doc (>= 2025.10~),
          ${misc:Depends}
 Description: transitional package
  This is a transitional package. It can safely be removed.
