=== python/opm/CMakeLists.txt ===
project(install_python_binding)

cmake_minimum_required(VERSION 3.15)

install(CODE "message(\"Dummy install\")")
