=== debian/changelog ===
opm-simulators (2025.10+ds-5) unstable; urgency=medium

  * Backported patches fixing cprw tests for DUNE 2.11
  * Correct pressure index also for getQuasiImpesWeights.
  * Fix build with boost 1.90 (Closes: 1127252)

 -- Markus Blatt <markus@dr-blatt.de>  Mon, 09 Feb 2026 13:32:42 +0100

opm-simulators (2025.10+ds-4) unstable; urgency=medium

  * d/rules: Exclude failing reservoir_ncp_ecfv from test on riscv64

 -- Markus Blatt <markus@dr-blatt.de>  Sat, 13 Dec 2025 14:53:19 +0100

opm-simulators (2025.10+ds-3) unstable; urgency=medium

  * d/rules: Really deactivate LTO on riscv64
  * d/rules: Pass -gno-variable-location-views on riscv64 to reduce compile time

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 09 Dec 2025 22:34:52 +0100

opm-simulators (2025.10+ds-2) unstable; urgency=medium

  * d/rules: Don't use LTO on riscv64 as it breaks tests.

 -- Markus Blatt <markus@dr-blatt.de>  Tue, 18 Nov 2025 16:30:46 +0100

opm-simulators (2025.10+ds-1) unstable; urgency=medium

  * New upstream version 2025.10+ds
  * Depend on OPM 2025.10
  * d/rules: Activate lto as this should be fixed upstream

 -- Markus Blatt <markus@dr-blatt.de>  Fri, 24 Oct 2025 17:25:46 +0200
