=== debian/control ===
--- 
+++ 
@@ -2,13 +2,30 @@
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Arne Morten Kvarving <arne.morten.kvarving@sintef.no>, Markus Blatt <markus@dr-blatt.de>
-Build-Depends: debhelper-compat (= 13), quilt, dh-sequence-python3, bc, chrpath,
-               libboost-system-dev, libboost-date-time-dev, libboost-test-dev,
-               zlib1g-dev, gfortran, pkgconf, lsb-release, libtool, doxygen,
-               texlive-latex-extra, texlive-latex-recommended, ghostscript,
+Build-Depends: debhelper-compat (= 13),
+               quilt,
+               dh-sequence-python3,
+               bc,
+               chrpath,
+               libboost-dev,
+               libboost-date-time-dev,
+               libboost-test-dev,
+               zlib1g-dev,
+               gfortran,
+               pkgconf,
+               lsb-release,
+               libtool,
+               doxygen,
+               texlive-latex-extra,
+               texlive-latex-recommended,
+               ghostscript,
                libopm-grid-dev (>= 2025.10~),
-	       mpi-default-dev, mpi-default-bin, python3-dev, libpython3-dev,
-	       pybind11-dev, libhdf5-mpi-dev
+               mpi-default-dev,
+               mpi-default-bin,
+               python3-dev,
+               libpython3-dev,
+               pybind11-dev,
+               libhdf5-mpi-dev
 Standards-Version: 4.7.2
 Section: libs
 Homepage: https://opm-project.org
