=== debian/rules ===
--- 
+++ 
@@ -7,7 +7,6 @@
 
 OPM_DEBIAN_CMAKE_FLAGS = -DOPM_ENABLE_PYTHON=1 -DOPM_INSTALL_PYTHON=1 -DPYTHON_EXECUTABLE=/usr/bin/python3 -DOPM_INSTALL_COMPILED_PYTHON=OFF  -DOPM_ENABLE_PYTHON_TESTS=0 -DCMAKE_BUILD_RPATH_USE_ORIGIN=ON
 
-
 OPM_DEBIAN_MK ?= /usr/share/opm/opm-debian.mk
 ifneq ("$(wildcard $(OPM_DEBIAN_MK))","")
    include $(OPM_DEBIAN_MK)
@@ -15,6 +14,19 @@
 OPM_LIB_DEBIAN_MK ?= /usr/share/opm/opm-lib-debian.mk
 ifneq ("$(wildcard $(OPM_LIB_DEBIAN_MK))","")
     include $(OPM_LIB_DEBIAN_MK) # for makeshlibs
+endif
+
+# We have failing tests with LTO on riscv64. Hence we deactivate it.
+ifneq (,$(filter $(DEB_HOST_ARCH), riscv64))
+    # Deactivate lto on Debian and in OPM (it will try to activate LTO if we do not set OPM_INTERPROCEDURAL_OPTIMIZATION_TYPE to NONE
+    export DEB_BUILD_MAINT_OPTIONS+=optimize=-lto
+    export OPM_DEBIAN_CMAKE_FLAGS+=-DOPM_INTERPROCEDURAL_OPTIMIZATION_TYPE=NONE
+
+    # The above is ignored. Hence exclude the buggy test from ctest
+    OPM_CTEST_OPTIONS = -E reservoir_ncp_ecfv
+
+    # Hopefully bring down build time, see https://lists.debian.org/debian-riscv/2025/09/msg00019.html
+    export DEB_CXXFLAGS_MAINT_APPEND +=-gno-variable-location-views
 endif
 
 # require 7GB of RAM per make process. Yes, peak seems to be above 6 GB currently
@@ -32,6 +44,8 @@
 	find debian/tmp/usr/bin -type f -exec chrpath -d '{}' \; || true
 	dh_install
 
+override_dh_auto_test:
+	dh_auto_test -- ARGS\+="$(OPM_CTEST_OPTIONS)"
 %:
 	echo "ram in gb: $(free_ram), needed ram per thread: $(need_gb_ram_per_process), threads: $(parallel_procs)"
 	dh $@ --max-parallel=$(parallel_procs)
